import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";


// A simple demo with some normals and angle measurement

hyperbolic_point A = hyperbolic_point(1,0);
hyperbolic_point B = hyperbolic_point(1,180);
dot(A, blue);
dot(B, blue);
hyperbolic_line l = hyperbolic_line(A, B);
draw(l, blue);

for (real ang = 0; ang <360; ang += 23) {
    hyperbolic_point C = hyperbolic_point(2.5,ang);
    hyperbolic_line N = hyperbolic_normal(l, C);
    draw(N, blue);
    dot(C, orange);
    hyperbolic_point I = intersection(l,N);
    real a = angle(N,l);
    write(a);
    string s = string(degrees(a), 4);
    label(s,I.get_euclidean());
}


draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
