import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";


// A simple demo with some normals and angle measurement
// Note that the angle between two lines is defined as the
// smaller one! There are no intersection angles > pi/2.

hyperbolic_point O = hyperbolic_point(0,0);
hyperbolic_point A = hyperbolic_point(1,0);
hyperbolic_point B = hyperbolic_point(1,180);
dot(A, blue);
dot(B, blue);
hyperbolic_line l = hyperbolic_line(A, B);
draw(l, blue);

for (real ang = 0; ang <360; ang += 17) {
    hyperbolic_point C = hyperbolic_point(2.5,ang);
    hyperbolic_line m = hyperbolic_line(O, C);
    draw(m, blue);
    dot(C, orange);
    real a = angle(m,l);
    write(a);
    string s = string(degrees(a), 4);
    label(s,C.get_euclidean());
}


draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
