import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";


// A simple test with angle calculation between three points.
// Here we are not restricted to angles < pi/2!

hyperbolic_point O = hyperbolic_point(0,0);
dot(O, black);
hyperbolic_point A = hyperbolic_point(1,0);
dot(A, blue);

hyperbolic_point B = hyperbolic_point(1,180);
dot(B, blue);

hyperbolic_line l = hyperbolic_line(O, A);
draw(l, blue);

for (real ang = 0; ang <=360; ang += 15) {
    hyperbolic_point C = hyperbolic_point(2.5,ang);

    hyperbolic_segment S = hyperbolic_segment(A,C);
    draw(S, black);
    hyperbolic_segment S = hyperbolic_segment(C,B);
    draw(S, black);

    dot(C, orange);
    real a = 0.0;
    a = angle(A,C,O);
    write(a);
    string s = string(degrees(a), 4);
    label(s,C.get_euclidean());
}


draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
