import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// A simple test with angle calculation between three points.
// We see that the angles become smaller and smaller as we
// move point C to infinity

hyperbolic_point O = hyperbolic_point(0,0);
dot(O, black);
hyperbolic_point A = hyperbolic_point(3,0);
dot(A, blue);
hyperbolic_point B = hyperbolic_point(3,180);
dot(B, blue);

hyperbolic_line l = hyperbolic_line(O, A);
draw(l, blue);

for (real rad = 0.1; rad <=5; rad += 0.5) {
    hyperbolic_point C = hyperbolic_point(rad,90);

    hyperbolic_segment S = hyperbolic_segment(A,C);
    draw(S, yellow);
    hyperbolic_segment S = hyperbolic_segment(C,B);
    draw(S, yellow);

    dot(C, blue);
    real a = 0.0;
    a = angle(A,C,B);
    write(a);
    string s = string(degrees(a), 4);
    label(s,C.get_euclidean());
}

hyperbolic_point A = hyperbolic_point(1,0);
dot(A, blue);
hyperbolic_point B = hyperbolic_point(1,180);
dot(B, blue);

for (real rad = 0.1; rad <=5; rad += 0.2) {
    hyperbolic_point C = hyperbolic_point(rad,270);

    hyperbolic_segment S = hyperbolic_segment(A,C);
    draw(S, yellow);
    hyperbolic_segment S = hyperbolic_segment(C,B);
    draw(S, yellow);

    dot(C, blue);
    real a = 0.0;
    a = angle(A,C,B);
    write(a);
    string s = string(degrees(a), 4);
    label(s,C.get_euclidean());
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
