import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// A simple test with angle calculation between three points.
// Here we are not restricted to angles < pi/2!

hyperbolic_point O = hyperbolic_point(0,0);
dot(O, black);

hyperbolic_point P = hyperbolic_point(2, 0);
hyperbolic_point Q;

for (real ang = 20; ang <=360; ang += 20) {
    Q = P;
    P = hyperbolic_point(2,ang);

    hyperbolic_segment S = hyperbolic_segment(O,Q);
    draw(S, black);
    dot(Q, orange);

    real a = 0.0;
    a = angle(P,O,Q);
    write(a);
    string s = string(degrees(a), 4);
    label(s,(Q.get_euclidean()+P.get_euclidean())/2);

    real a = 0.0;
    a = angle(P,Q,O);
    write(a);
    string s = string(degrees(a), 4);
    label(s,(Q.get_euclidean()+0.5*P.get_euclidean())/2);

    real a = 0.0;
    a = angle(Q,P,O);
    write(a);
    string s = string(degrees(a), 4);
    label(s,(0.5*Q.get_euclidean()+P.get_euclidean())/2);

}


draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
