import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Construction of angle bisector

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

hyperbolic_point A = hyperbolic_point(1.8,80);
hyperbolic_point B = hyperbolic_point(2.2,300);
hyperbolic_point C = hyperbolic_point(1.1,30);
dot(A);
dot(B);
dot(C);


hyperbolic_ray R1 = hyperbolic_ray(B,A);
hyperbolic_ray R2 = hyperbolic_ray(B,C);
hyperbolic_line bis = angle_bisector(A,B,C);
draw(R1, blue);
draw(R2, blue);
draw(bis, orange);
real l = degrees(angle(R1.get_line(), R2.get_line()));
write(l);
real l = degrees(angle(R1.get_line(), bis));
write(l);
real l = degrees(angle(R2.get_line(), bis));
write(l);


hyperbolic_ray R1 = hyperbolic_ray(O,A);
hyperbolic_ray R2 = hyperbolic_ray(O,C);
hyperbolic_line bis = angle_bisector(A,O,C);
draw(R1, blue);
draw(R2, blue);
draw(bis, orange);
real l = degrees(angle(R1.get_line(), R2.get_line()));
write(l);
real l = degrees(angle(R1.get_line(), bis));
write(l);
real l = degrees(angle(R2.get_line(), bis));
write(l);


// Angle bisectors of two given lines
hyperbolic_point A = hyperbolic_point(1.8,80);
hyperbolic_point B = hyperbolic_point(2.2,120);
hyperbolic_point C = hyperbolic_point(1.1,150);
dot(A);
dot(B);
dot(C);


hyperbolic_line L1 = hyperbolic_line(A,B);
hyperbolic_line L2 = hyperbolic_line(B,C);
hyperbolic_line[] bis = angle_bisector(L2,L1);
draw(L1, blue);
draw(L2, blue);
draw(bis[0], red);
draw(bis[1], green);
real l = degrees(angle(L1, L2));
write(l);
real l = degrees(angle(L1, bis[1]));
write(l);
real l = degrees(angle(L2, bis[1]));
write(l);
real l = degrees(pi-angle(L1, L2));
write(l);
real l = degrees(angle(L1, bis[0]));
write(l);
real l = degrees(angle(L2, bis[0]));
write(l);
real l = degrees(angle(bis[0], bis[1]));
write(l);


draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
