import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// "Assure" a circle is really a circle be measuring
// radial distances.

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

hyperbolic_point C = hyperbolic_point(2,60);
hyperbolic_point P = hyperbolic_point(1,310);
hyperbolic_segment S = hyperbolic_segment(C,P);

hyperbolic_circle circ = hyperbolic_circle(C,P);

hyperbolic_point Q;
hyperbolic_line R;
hyperbolic_point[] I;
hyperbolic_segment T;

for(real ang = 0; ang <= 180; ang += 20) {
    Q = hyperbolic_point(1, ang);
    R = hyperbolic_line(O,Q);
    I = intersection(circ, R);

    T = hyperbolic_segment(C,I[0]);
    draw(T, gray);
    T = hyperbolic_segment(C,I[1]);
    draw(T, gray);

    draw(R);
    dot(I);

    real d0 = hyperbolic_distance(C, I[0]);
    real d1 = hyperbolic_distance(C, I[1]);
    string s = string(d0, 4);
    label(s,I[0].get_euclidean());
    string s = string(d1, 4);
    label(s,I[1].get_euclidean());
}

draw(circ, blue);
draw(S, blue);
dot(C, black);
dot(P, blue);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
