import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Circles with fixed center and variable peripherical point.
// We test if both branches of the circle calculation algorithm
// give usable result. The calculated circles should depend
// smoothly on the peripherical point transformation.

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

hyperbolic_point C = hyperbolic_point(1.2,60);
hyperbolic_point P = hyperbolic_point(0.4,60);
hyperbolic_segment S = hyperbolic_segment(C,P);

draw(S, black);
dot(C, blue);
dot(P, blue);

hyperbolic_point X;
hyperbolic_line l;
hyperbolic_circle circ;
for(real ang = 0; ang < 360; ang+= 10) {
    X = hyperbolic_point(0.4,ang);
    l = hyperbolic_line(O,X);
    circ = hyperbolic_circle(C,X);

    pair cent = circ.get_center();

    draw(l, gray);
    draw(circ, blue);
    dot(X, blue);
    dot(cent, orange);
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
