import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// A simple demo with common perpendiculars

// Test common perpendicular on two arbitrary non-diameter lines
hyperbolic_point A = hyperbolic_point(1.6,200);
hyperbolic_point B = hyperbolic_point(2,310);
dot(A, blue);
dot(B, blue);
hyperbolic_line a = hyperbolic_line(A, B);
draw(a, blue);

hyperbolic_point C = hyperbolic_point(1.5, 45);
hyperbolic_point D = hyperbolic_point(1.5, 170);
dot(C, blue);
dot(D, blue);
hyperbolic_line b = hyperbolic_line(C, D);
draw(b, blue);

hyperbolic_line z = common_perpendicular(a, b);
draw(z, red);
dot(z.get_first_endpoint());
dot(z.get_second_endpoint());

hyperbolic_point Z = intersection(a, z);
hyperbolic_point Y = intersection(b, z);
dot(Z);
dot(Y);


// Test common perpendicular with a diameter-line
hyperbolic_point E = hyperbolic_point(1.2, 10);
hyperbolic_point F = hyperbolic_point(1.2, 190);
dot(E, blue);
dot(F, blue);
hyperbolic_line c = hyperbolic_line(E, F);
draw(c, blue);

hyperbolic_point G = hyperbolic_point(1.0,30);
hyperbolic_point H = hyperbolic_point(1.0,120);
dot(G, blue);
dot(H, blue);
hyperbolic_line d = hyperbolic_line(G, H);
draw(d, blue);

hyperbolic_point I = hyperbolic_point(1.5, 45);
hyperbolic_point J = hyperbolic_point(1.5, 90);
dot(I, blue);
dot(J, blue);
hyperbolic_line e = hyperbolic_line(I, J);
draw(e, blue);

hyperbolic_line y = common_perpendicular(c, d);
draw(y, red);
dot(y.get_first_endpoint());
dot(y.get_second_endpoint());

hyperbolic_point X = intersection(y, c);
hyperbolic_point W = intersection(y, d);
dot(X);
dot(W);

hyperbolic_line x = common_perpendicular(e, c);
draw(x, red);
dot(x.get_first_endpoint());
dot(x.get_second_endpoint());

hyperbolic_point V = intersection(c, x);
hyperbolic_point U = intersection(e, x);
dot(V);
dot(U);


// Test common perpendicular on two non-diameter lines with collinear centers
hyperbolic_point K = hyperbolic_point(0.5,350);
hyperbolic_point L = hyperbolic_point(0.5,260);
dot(K, blue);
dot(L, blue);
hyperbolic_line f = hyperbolic_line(K, L);
draw(f, blue);

hyperbolic_point M = hyperbolic_point(2.5, 350);
hyperbolic_point N = hyperbolic_point(2.5, 260);
dot(M, blue);
dot(N, blue);
hyperbolic_line g = hyperbolic_line(M, N);
draw(g, blue);

hyperbolic_line w = common_perpendicular(f, g);
draw(w, red);
dot(w.get_first_endpoint());
dot(w.get_second_endpoint());

hyperbolic_point T = intersection(f, w);
hyperbolic_point S = intersection(g, w);
dot(T);
dot(S);


dot(origin);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
