import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// Here we show the construction of a perpendicular.
// This is done in analogy to the classical euclidean geometry.

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

// The two points A, B given
hyperbolic_point A = hyperbolic_point(1.5,30);
hyperbolic_point B = hyperbolic_point(1.5,140);

// The line L connection the A, B
hyperbolic_line L = hyperbolic_line(A,B);

// The point through which the perpendicular goes.
hyperbolic_point P = hyperbolic_point(2,80);

// The circle for finding the two base points
hyperbolic_circle C = hyperbolic_circle(P,A);

// Intersect the two circles, resulting in the points I1, I2
hyperbolic_point[] I = intersection(C,L);

// Two circles with center {I0,I1} going through P
hyperbolic_circle C1 = hyperbolic_circle(I[0],P);
hyperbolic_circle C2 = hyperbolic_circle(I[1],P);

// Intersect the two circles, resulting in the points J1, J2
hyperbolic_point[] J = intersection(C1,C2);

// Put a line N through the two intersection points J1,J2
hyperbolic_line N = hyperbolic_line(J[0], J[1]);


// And draw all the stuff
draw(C, gray);
draw(C1, orange);
draw(C2, orange);
draw(L, black);
draw(N, blue);
dot(I[0], gray);
dot(I[1], gray);
dot(J[0], gray);
dot(J[1], gray);
dot(A, black);
dot(B, black);
dot(P, black);


draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
