import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// We have some points at given euclidean coordinates
// and want to calculate the hyperbolic coordinates.
// Some of the points lie outside the unit disk.
//
// To draw the points, we transform them back to euclidean
// coordinates. All original points are orange, all points
// inside the unit disk should be blue.

dot((0,0), red);

for (int i = 0; i <= 20; ++i) {
    for (int j = 0; j <= 20; ++j) {
        pair pp = (-1+i*0.1, -1+j*0.1);
        dot(pp, orange);

        real[] point = to_hyperbolic(pp);

        pair qq = to_euclidean(point[0], point[1]);
        dot(qq, blue);
    }
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
