import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Hyperbolic distances between some more or less random points.

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

hyperbolic_point A = hyperbolic_point(1,0);
hyperbolic_point B = hyperbolic_point(2,270);
hyperbolic_point C = hyperbolic_point(1,60);
hyperbolic_point D = hyperbolic_point(1,180);
hyperbolic_point E = hyperbolic_point(2,0);
hyperbolic_point F = hyperbolic_point(2,60);
hyperbolic_point G = hyperbolic_point(3,0);

dot(A);
dot(B);
dot(C);
dot(D);
dot(E);
dot(F);
dot(G);

hyperbolic_segment s = hyperbolic_segment(O,A);
draw(s);

hyperbolic_segment s = hyperbolic_segment(O,B);
draw(s);

hyperbolic_segment s = hyperbolic_segment(C,A);
draw(s);

hyperbolic_segment s = hyperbolic_segment(O,D);
draw(s);

hyperbolic_segment s = hyperbolic_segment(C,D);
draw(s);

hyperbolic_segment s = hyperbolic_segment(O,C);
draw(s);

hyperbolic_segment s = hyperbolic_segment(A,E);
draw(s);

hyperbolic_segment s = hyperbolic_segment(F,E);
draw(s);

hyperbolic_segment s = hyperbolic_segment(F,C);
draw(s);

hyperbolic_segment s = hyperbolic_segment(G,E);
draw(s);

hyperbolic_segment s = hyperbolic_segment(G,B);
draw(s);

real l = hyperbolic_distance(O,A);
string s = string(l, 3);
label(s,(O.get_euclidean()+A.get_euclidean())/2);

real l = hyperbolic_distance(O,B);
string s = string(l, 3);
label(s,(O.get_euclidean()+B.get_euclidean())/2);

real l = hyperbolic_distance(C,A);
string s = string(l, 3);
label(s,(C.get_euclidean()+A.get_euclidean())/2);

real l = hyperbolic_distance(O,D);
string s = string(l, 3);
label(s,(O.get_euclidean()+D.get_euclidean())/2);

real l = hyperbolic_distance(C,D);
string s = string(l, 3);
label(s,(C.get_euclidean()+D.get_euclidean())/2);

real l = hyperbolic_distance(O,C);
string s = string(l, 3);
label(s,(O.get_euclidean()+C.get_euclidean())/2);

real l = hyperbolic_distance(A,E);
string s = string(l, 3);
label(s,(A.get_euclidean()+E.get_euclidean())/2);

real l = hyperbolic_distance(E,F);
string s = string(l, 3);
label(s,(E.get_euclidean()+F.get_euclidean())/2);

real l = hyperbolic_distance(C,F);
string s = string(l, 3);
label(s,(C.get_euclidean()+F.get_euclidean())/2);

real l = hyperbolic_distance(E,G);
string s = string(l, 3);
label(s,(E.get_euclidean()+G.get_euclidean())/2);

real l = hyperbolic_distance(B,G);
string s = string(l, 3);
label(s,(B.get_euclidean()+G.get_euclidean())/2);


draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
