import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Hyperbolic distances between radialsymmetric points

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

for(int i = 0; i <12; ++i) {
	hyperbolic_point X = hyperbolic_point(1,i*30);
	dot(X,red);
	hyperbolic_segment s = hyperbolic_segment(O,X);
	draw(s,red);
	real l = hyperbolic_distance(O,X);
	string s = string(l, 3);
	label(s,21.5/20*X.get_euclidean(),red);
	hyperbolic_point Y = hyperbolic_point(1,(i-1)*30);
	hyperbolic_segment s = hyperbolic_segment(X,Y);
	draw(s,red);
	real l = hyperbolic_distance(X,Y);
	string s = string(l, 3);
	label(s,(X.get_euclidean()+Y.get_euclidean())/2,red);
}

for(int i = 0; i <12; ++i) {
	hyperbolic_point X = hyperbolic_point(2,i*30+10);
	dot(X, blue);
	hyperbolic_segment s = hyperbolic_segment(O,X);
	draw(s,blue);
	real l = hyperbolic_distance(O,X);
	string s = string(l, 3);
	label(s,21.5/20*X.get_euclidean(),blue);
	hyperbolic_point Y = hyperbolic_point(2,(i-1)*30+10);
	hyperbolic_segment s = hyperbolic_segment(X,Y);
	draw(s,blue);
	real l = hyperbolic_distance(X,Y);
	string s = string(l, 3);
	label(s,(X.get_euclidean()+Y.get_euclidean())/2,blue);
}

for(int i = 0; i <12; ++i) {
	hyperbolic_point X = hyperbolic_point(3,i*30+20);
	dot(X,green);
	hyperbolic_segment s = hyperbolic_segment(O,X);
	draw(s,green);
	real l = hyperbolic_distance(O,X);
	string s = string(l, 3);
	label(s,21.5/20*X.get_euclidean(),green);
	hyperbolic_point Y = hyperbolic_point(3,(i-1)*30+20);
	hyperbolic_segment s = hyperbolic_segment(X,Y);
	draw(s,green);
	real l = hyperbolic_distance(X,Y);
	string s = string(l, 3);
	label(s,(X.get_euclidean()+Y.get_euclidean())/2,green);
}


draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
