import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Points are set by euclidean coordinates and
// their distance from the origin ist calculated.
// This time, the distance is calculated via hyperbolic_distance()
// Result has to be the same as points_test2.asy (left half)!

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

for (real j = -0.7; j <= 0.7; j += 0.1) {
    for (real i = -0.7; i <= 0.7; i += 0.1) {
        pair A = (i, j);
        hyperbolic_point X = hyperbolic_point(A);
        dot(X, orange);
        real l = hyperbolic_distance(O, X);
        string s = string(l, 2);
        label(s,X.get_euclidean());
    }
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
