import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Intersection calculation of hyperbolic lines
// If there is no intersection for two lines, the
// common perpendicular is calculated.

hyperbolic_line[] lines;

hyperbolic_point A = hyperbolic_point(1,0);
hyperbolic_point B = hyperbolic_point(1,180);
dot(A);
dot(B);
lines[0] = hyperbolic_line(A,B);

hyperbolic_point A = hyperbolic_point(1,90);
hyperbolic_point B = hyperbolic_point(1,270);
dot(A);
dot(B);
lines[1] = hyperbolic_line(A,B);

hyperbolic_point A = hyperbolic_point(1,30);
hyperbolic_point B = hyperbolic_point(1,120);
dot(A);
dot(B);
lines[2] = hyperbolic_line(A,B);

hyperbolic_point A = hyperbolic_point(1,60);
hyperbolic_point B = hyperbolic_point(1,150);
dot(A);
dot(B);
lines[3] = hyperbolic_line(A,B);

hyperbolic_point A = hyperbolic_point(1,135);
hyperbolic_point B = hyperbolic_point(1,315);
dot(A);
dot(B);
lines[4] = hyperbolic_line(A,B);

hyperbolic_point A = hyperbolic_point(1.5,0);
hyperbolic_point B = hyperbolic_point(1.5,270);
dot(A);
dot(B);
lines[5] = hyperbolic_line(A,B);

hyperbolic_point A = hyperbolic_point(1,115);
hyperbolic_point B = hyperbolic_point(1,295);
dot(A);
dot(B);
lines[6] = hyperbolic_line(A,B);

hyperbolic_point A = hyperbolic_point(0.75,170);
hyperbolic_point B = hyperbolic_point(0.5,210);
dot(A);
dot(B);
lines[7] = hyperbolic_line(A,B);

hyperbolic_point A = hyperbolic_point(2,70);
hyperbolic_point B = hyperbolic_point(2,230);
dot(A);
dot(B);
lines[8] = hyperbolic_line(A,B);

hyperbolic_point A = hyperbolic_point(2,190);
hyperbolic_point B = hyperbolic_point(2,340);
dot(A);
dot(B);
lines[9] = hyperbolic_line(A,B);

hyperbolic_point A = hyperbolic_point(0.6,40);
hyperbolic_point B = hyperbolic_point(0.6,320);
dot(A);
dot(B);
lines[10] = hyperbolic_line(A,B);

// string s;
for (int i = 0; i < lines.length; ++i) {
    draw(lines[i]);
//     s = string(i, 2);
//     label(s, 1.05*lines[i].get_first_endpoint() ,red);
    for (int j = 0; j < i; ++j) {
        if (do_intersect(lines[i], lines[j])) {
            hyperbolic_point I = intersection(lines[i], lines[j]);
            dot(I, orange);
        } else {
            hyperbolic_point[] BP = common_basepoints(lines[i], lines[j]);
            hyperbolic_segment S = hyperbolic_segment(BP[0], BP[1]);
            draw(S, blue);
            dot(BP, blue);
        }
    }
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
