import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Calculation of many intersection points
// Note: some do not exist. Instead, the point
// will be set to the origin ...

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

hyperbolic_point P = hyperbolic_point(1, 0);
hyperbolic_point R = hyperbolic_point(1, 180);

int many = 16;

hyperbolic_line[] bl;
hyperbolic_line[] rl;

for (int j = 1; j < many+1; ++j) {
    hyperbolic_point Q = hyperbolic_point(1, j*360/(many+1));
    bl[j-1] = hyperbolic_line(P, Q);
    rl[j-1] = hyperbolic_line(R, Q);
    draw(bl[j-1], blue);
    draw(rl[j-1], red);
}

for (int i = 0; i <= many-1; ++i) {
    for (int j = 0; j <= many-1; ++j) {
        hyperbolic_point I;
        I = intersection(rl[i], bl[j]);
        dot(I, black);
    }
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
