import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Points are set by euclidean coordinates and
// their distance from the origin ist calculated.
// Right half, the euclidean metric, left
// half the hyperbolic metric is used.

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

for (real rad = 0.1; rad < 5; rad += 0.5) {
    // Euclidean distance showed
    for (real ang = 0; ang < 180; ang += 10) {
        pair A= to_euclidean(rad, ang);
        hyperbolic_point X = hyperbolic_point(A);
        dot(X, red);
        real l = length(X.get_euclidean()); // relpace this with euclidean_distance()
        string s = string(l, 2);
        label(s,X.get_euclidean());
    }
    // Hyperbolic distance showed
    for (real ang = 180; ang < 360; ang += 10) {
        pair A = to_euclidean(rad, ang);
        hyperbolic_point X = hyperbolic_point(A);
        dot(X, yellow);
        real l = hyperbolic_distance(O, X);
        string s = string(l, 2);
        label(s,X.get_euclidean());
    }
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
