import math;
import hyperbolic_geometry;

size(500,500);

settings.outformat="pdf";

// A simple demo on how to construct midpoints

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

void write_d(hyperbolic_point X, hyperbolic_point Y) {
    real r = hyperbolic_distance(X, Y);
    write(r);
    string s = string(r, 4);
    label(s,(X.get_euclidean()+Y.get_euclidean())/2,blue);
}

hyperbolic_point X = hyperbolic_point(2, 60);
hyperbolic_point Y = hyperbolic_point(2, 120);
hyperbolic_line L = hyperbolic_line(X, Y);
draw(L, black);
dot(X, black);
dot(Y, black);
hyperbolic_point M = midpoint(X, Y);
dot(M, blue);
write_d(X, Y);
write_d(X, M);
write_d(M, Y);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
