import math;
import hyperbolic_geometry;

size(500,500);

settings.outformat="pdf";

// A simple demo on how to construct midpoints

hyperbolic_point O = hyperbolic_point(0,0);


void write_d(hyperbolic_point X, hyperbolic_point Y) {
    real r = hyperbolic_distance(X, Y);
    write(r);
    string s = string(r, 4);
    label(s,(X.get_euclidean()+Y.get_euclidean())/2,blue);
}


for ( int angle = 0; angle < 60; angle += 50) {
    hyperbolic_point X = hyperbolic_point(2, angle);
    hyperbolic_point Y = hyperbolic_point(0, angle);
    hyperbolic_segment L = hyperbolic_segment(X, Y);
    draw(L);
    dot(X);
    dot(Y);
    hyperbolic_point M = midpoint(X, Y);
    dot(M, blue);

    write_d(X, M);
    write_d(M, Y);
}


    hyperbolic_point X = hyperbolic_point(2, 0);
    hyperbolic_point Y = hyperbolic_point(0, 0);
    hyperbolic_segment L = hyperbolic_segment(X, Y);
    draw(L);
    dot(X);
    dot(Y);
    hyperbolic_point M = midpoint(X, Y);
    dot(M, green);

    write_d(X, M);
    write_d(M, Y);

dot(O,red);
draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
