import math;
import hyperbolic_geometry;

size(500,500);

settings.outformat="pdf";

// A simple demo with midpoints

hyperbolic_point O = hyperbolic_point(0,0);


void write_d(hyperbolic_point X, hyperbolic_point Y) {
    real r = hyperbolic_distance(X, Y);
    write(r);
    string s = string(r, 4);
    label(s,(X.get_euclidean()+Y.get_euclidean())/2+(0,-0.1),blue);
}

hyperbolic_point X = hyperbolic_point(4, 20);
hyperbolic_point Y = hyperbolic_point(4, 160);
dot(X);
dot(Y);

for ( int i = 0; i < 6; ++i) {
    hyperbolic_segment L = hyperbolic_segment(X, Y);
    draw(L);

    hyperbolic_point M = midpoint(X, Y);
    dot(M, blue);

    write_d(X, Y);

    Y = M;
}


X = hyperbolic_point(4, 200);
Y = hyperbolic_point(4, 340);
hyperbolic_point N = midpoint(X, Y);
dot(X);
dot(Y);
dot(N);

for ( int i = 0; i < 6; ++i) {
    hyperbolic_segment L = hyperbolic_segment(X, Y);
    draw(L);

    hyperbolic_point M1 = midpoint(X, N);
    dot(M1, blue);
    hyperbolic_point M2 = midpoint(Y, N);
    dot(M2, blue);

    write_d(X, M1);
    write_d(Y, M2);

    X = M1;
    Y = M2;
}

dot(O,red);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
