import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Mirroring hyperbolic circles at hyperbolic lines.

hyperbolic_point A = hyperbolic_point(1,90);
hyperbolic_point B = hyperbolic_point(1,30);
hyperbolic_line M = hyperbolic_line(A,B);

draw(M, blue);
dot(A, blue);
dot(B, blue);

hyperbolic_point A = hyperbolic_point(1,30);
hyperbolic_point B = hyperbolic_point(1,210);
hyperbolic_line N = hyperbolic_line(A,B);

draw(N, yellow);
dot(A, blue);
dot(B, blue);

hyperbolic_point[] P;
hyperbolic_point[] Q;

P[0] = hyperbolic_point(2,45);
Q[0] = hyperbolic_point(2.5,60);
P[1] = hyperbolic_point(3,90);
Q[1] = hyperbolic_point(3.5,100);
P[2] = hyperbolic_point(4,70);
Q[2] = hyperbolic_point(4.5,72);
P[3] = hyperbolic_point(1,280);
Q[3] = hyperbolic_point(1,290);
P[4] = hyperbolic_point(0,0);
Q[4] = hyperbolic_point(1,350);
P[5] = hyperbolic_point(2,275);
Q[5] = hyperbolic_point(0,90);

hyperbolic_point MP;
hyperbolic_point MQ;
hyperbolic_segment T;
hyperbolic_circle[] C;
hyperbolic_circle D;

for(int i = 0; i < P.length; ++i) {
    C[i] = hyperbolic_circle(P[i],Q[i]);
    draw(C, black);
    dot(P[i], black);
    //dot(Q[i], black);
}

for(int i = 0; i < P.length; ++i) {
    MP = mirror(M, P[i]);
    MQ = mirror(M, Q[i]);
    T = hyperbolic_segment(P[i],MP);
    D = mirror(M, C[i]);
    draw(T, gray);
    draw(D, red);
    dot(MP, red);
    //dot(MQ, red);
}

for(int i = 0; i < P.length; ++i) {
    MP = mirror(N, P[i]);
    MQ = mirror(N, Q[i]);
    T = hyperbolic_segment(P[i],MP);
    D = mirror(N, C[i]);
    draw(T, gray);
    draw(D, orange);
    dot(MP, orange);
    //dot(MQ, orange);
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
