import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Mirroring hyperbolic points at hyperbolic rays. The red/orange points are the mirror
// images of the black/gray ones.

hyperbolic_point O = hyperbolic_point(0,0);

hyperbolic_point A = hyperbolic_point(2,130);
hyperbolic_point B = hyperbolic_point(1,30);
hyperbolic_ray M = hyperbolic_ray(O,A);
hyperbolic_ray N = hyperbolic_ray(O,B);
dot(A, blue);
dot(B, blue);
draw(M, blue);
draw(N, yellow);

hyperbolic_point P;
hyperbolic_point Q;
hyperbolic_segment S;
hyperbolic_point I;
string s;
real l;

for(real ang = 0; ang < 360; ang += 20) {
    P = hyperbolic_point(2, ang);
    Q = mirror(M, P);

    S = hyperbolic_segment(P, Q);
    draw(S, gray);

    dot(P, black);
    dot(Q, red);

    I = intersection(M, S);
    //dot(I, gray);

    // Measurements which show the mirroring in numbers
    l = hyperbolic_distance(P,I);
    s = string(l, 2);
    //label(s,P.get_euclidean());
    l = hyperbolic_distance(Q,I);
    s = string(l, 2);
    //label(s,Q.get_euclidean());
}

for(real ang = 10; ang < 360; ang += 20) {
    P = hyperbolic_point(2, ang);
    Q = mirror(N, P);

    S = hyperbolic_segment(P, Q);
    draw(S, gray);

    dot(P, gray);
    dot(Q, orange);

    I = intersection(N, S);
    //dot(I, gray);

    // Measurements which show the mirroring in numbers
    l = hyperbolic_distance(P,I);
    s = string(l, 2);
    //label(s,P.get_euclidean());
    l = hyperbolic_distance(Q,I);
    s = string(l, 2);
    //label(s,Q.get_euclidean());
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
