import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// Just recursive mirroring of polygons at their sides.

hyperbolic_point O = hyperbolic_point(0,0);

int numsides = 5;

pen pn=red;
int maxrec = 2;
int rec_flag = 0;
void recursive_mirror(hyperbolic_polygon[] polys) {
    if(rec_flag >= maxrec) {
        return;
    }
    ++rec_flag;

    write("rec level is");
    write(rec_flag);

    hyperbolic_segment[] sides;
    hyperbolic_polygon[] P;
    for (int p =0; p < polys.length; ++p) {
        sides = polys[p].get_sides();
        for(int i = 0; i < sides.length; ++i) {
            P[0] = mirror(sides[i], polys[p]);
            recursive_mirror(P);
            fill(P[0], pn+opacity(1.0/(3.0*rec_flag)));
            draw(P[0]);
            dot(P[0]);
        }
    }
    --rec_flag;
    return;
}

for (real radius = 2.2; radius >= 0.2; radius -= 0.2) {
    hyperbolic_point[] P0;
    for(int i = 0; i < numsides; ++i) {
        P0[i] = hyperbolic_point(radius, i*360/numsides);
    }
    hyperbolic_polygon[] pol0;
    pol0[0] = hyperbolic_polygon(P0);

    pn = 1/radius*(green+0.4*blue);
    recursive_mirror(pol0);
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
