import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Mirroring hyperbolic segments at hyperbolic lines. The mirror
// sequence is gray to orange to yellow to red

hyperbolic_point A = hyperbolic_point(1,90);
hyperbolic_point B = hyperbolic_point(1,30);
hyperbolic_line M = hyperbolic_line(A,B);
draw(M, blue);
dot(A, blue);
dot(B, blue);

hyperbolic_point C = hyperbolic_point(3, 40+180);
hyperbolic_point D = hyperbolic_point(3, 220+180);
hyperbolic_line N = hyperbolic_line(C, D);
draw(N, blue);
dot(C, blue);
dot(D, blue);

hyperbolic_point E = hyperbolic_point(1, 120);
hyperbolic_point F = hyperbolic_point(0.5, 245);
hyperbolic_line O = hyperbolic_line(E, F);
draw(O, blue);
dot(E, blue);
dot(F, blue);

hyperbolic_point[] P;
hyperbolic_point[] Q;

P[0] = hyperbolic_point(2, 45);
Q[0] = hyperbolic_point(1.2, 10);
P[1] = hyperbolic_point(1.2, 120);
Q[1] = hyperbolic_point(1.2, 10);
P[2] = hyperbolic_point(3,45);
Q[2] = hyperbolic_point(2.5,60);
P[3] = hyperbolic_point(3,90);
Q[3] = hyperbolic_point(3.5,100);
P[4] = hyperbolic_point(4,70);
Q[4] = hyperbolic_point(4.5,72);
P[5] = hyperbolic_point(1,280);
Q[5] = hyperbolic_point(1,290);

hyperbolic_segment G;
hyperbolic_segment H;
hyperbolic_segment I;
hyperbolic_segment J;

for(int i=0; i < P.length; ++i) {
    dot(P[i], gray);
    dot(Q[i], gray);

    G = hyperbolic_segment(P[i], Q[i]);
    H = mirror(M, G);
    I = mirror(N, H);
    J = mirror(O, I);
    draw(G, gray);
    draw(H, orange);
    draw(I, yellow);
    draw(J, red);
    dot(G.get_first_point(), gray);
    dot(G.get_second_point(), gray);
    dot(H.get_first_point(), orange);
    dot(H.get_second_point(), orange);
    dot(I.get_first_point(), yellow);
    dot(I.get_second_point(), yellow);
    dot(J.get_first_point(), red);
    dot(J.get_second_point(), red);
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
