import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";


// A simple demo with some normals

hyperbolic_point A = hyperbolic_point(1.6,200);
hyperbolic_point B = hyperbolic_point(2,310);
dot(A, blue);
dot(B, blue);
hyperbolic_line a = hyperbolic_line(A, B);
draw(a, blue);

hyperbolic_point C = hyperbolic_point(1.5, 45);
hyperbolic_point D = hyperbolic_point(1.5, 225);
dot(C, blue);
dot(D, blue);
hyperbolic_line b = hyperbolic_line(C, D);
draw(b, blue);

hyperbolic_point E = hyperbolic_point(2,140);
hyperbolic_point F = hyperbolic_point(2,40);
dot(E, blue);
dot(F, blue);
hyperbolic_line c = hyperbolic_line(E, F);
draw(c, blue);

hyperbolic_point[] points;

int n = 6;
for (int i = 0; i < n; i+=1) {
    points[i] = hyperbolic_point(1+i%3/6, 360.0/n*i);
}

dot(points, black);

for (int i = 0; i < n; i+=1) {
//     hyperbolic_line K = hyperbolic_normal(a, points[i]);
//     hyperbolic_line L = hyperbolic_normal(b, points[i]);
//     hyperbolic_line M = hyperbolic_normal(c, points[i]);
//     draw(K, orange);
//     draw(L, orange);
//     draw(M, orange);
    hyperbolic_point P = basepoint(a, points[i]);
    hyperbolic_point Q = basepoint(b, points[i]);
    hyperbolic_point R = basepoint(c, points[i]);
    hyperbolic_segment Z = hyperbolic_segment(points[i], P);
    hyperbolic_segment Y = hyperbolic_segment(points[i], Q);
    hyperbolic_segment X = hyperbolic_segment(points[i], R);
    draw(Z);
    draw(Y);
    draw(X);
    dot(P, orange);
    dot(Q, orange);
    dot(R, orange);
}

// Note on nummerical(?) instability:
// for n=5, the 2nd na d for n=7 the 5th
// point have normals which are wrong!

dot(origin, red);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
