import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// A simple kind of tiling

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

real r0 = 0.25;
int shells = 7;
int sides = 8;
int anz = sides;

hyperbolic_point[][] data;

for (int j = 1; j <= shells; ++j) {
    anz = 2^(j-1)*sides;
    hyperbolic_point[] cdata;
    real ang = 360/anz;
    for (int i = 0; i < anz; ++i) {
        cdata[i] = hyperbolic_point(j*r0,ang*i);
    }
    data[j-1] = cdata;
}

for (int shell = 1; shell < shells; ++shell) {
    int anzf = sides*2^(shell-1);
    for (int face = 0; face < anzf; ++face) {
        hyperbolic_point[] points;
        // inner points
        points[0] = data[shell-1][(face)%anzf];
        points[1] = data[shell-1][(face+1)%anzf];
        // outer points
        points[2] = data[shell][(2*face+2)%(2*anzf)];
        points[3] = data[shell][(2*face+1)%(2*anzf)];
        points[4] = data[shell][(2*face+0)%(2*anzf)];
        hyperbolic_polygon P = hyperbolic_polygon(points);
        fill(P.to_path(), face/anzf*green+(anzf-face)/anzf*blue+opacity(1.0*2^(-0.5*(shells-(shell-1)))));
        draw(P.to_path());
        dot(points);
    }
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
