import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// The calculation of intersection points of hyperbolic rays with hyperbolic segments
// Every intersection of a blue line (segment) with a green line (ray) in the picture
// should be marked with a red dot. There should no red dot appear elsewhere.

hyperbolic_point[] P;

P[0] = hyperbolic_point(1,30);
P[1] = hyperbolic_point(1,60);
P[2] = hyperbolic_point(2.4,210);
P[3] = hyperbolic_point(1.2,135);
P[4] = hyperbolic_point(0,5);
P[5] = hyperbolic_point(2,5);
P[6] = hyperbolic_point(2.8,80);
P[7] = hyperbolic_point(2.8,100);
P[8] = hyperbolic_point(1.2,80);
P[9] = hyperbolic_point(1.2,100);
P[10] = hyperbolic_point(1.6,200);
P[11] = hyperbolic_point(2,330);
P[12] = hyperbolic_point(1,130);
P[13] = hyperbolic_point(1.3,30);
P[14] = hyperbolic_point(1.8,65);
P[15] = hyperbolic_point(1.9,245);
P[16] = hyperbolic_point(2.8,40);
P[17] = hyperbolic_point(2.8,170);
P[18] = hyperbolic_point(1.2,30);
P[19] = hyperbolic_point(1.2,160);
P[20] = hyperbolic_point(1.6,220);
P[21] = hyperbolic_point(1,65);

hyperbolic_segment S[];
hyperbolic_ray R[];
hyperbolic_point I;

for (int i=0; i< 10; ++i) {
    S[i] = hyperbolic_segment(P[i],P[(i+1)]);

    dot(S[i].get_first_point(), gray);
    dot(S[i].get_second_point(), gray);
    dot(P[(i+1)], gray);

    draw(S[i].get_line(), gray);
    draw(S[i], blue);
}

for (int i=10; i< 20; ++i) {
    R[i-10] = hyperbolic_ray(P[i],P[(i+1)]);

    dot(R[i-10].get_point(), gray);
    dot(P[(i+1)], gray);

    draw(R[i-10].get_line(), gray);
    draw(R[i-10], green);
}

for (int i = 0; i < S.length; ++i) {
    for (int j = 0; j < R.length; ++j) {
        I = intersection(S[i], R[j]);
        dot(I, red);
    }
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
