import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Some demos with regular n gons

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

hyperbolic_point P;
hyperbolic_point Q;
hyperbolic_point M;
hyperbolic_point T = hyperbolic_point();
hyperbolic_polygon W;
hyperbolic_circle circ;

int maxsteps = 5;
real radius = 1.0;

for(int s = 3; s <= maxsteps; ++s) {
    P = hyperbolic_point(radius, 20);
    dot(P, black);
    for(int i = 0; i <= s; ++i) {
        Q = rotate_around_origin(P, i*360/s);
        dot(Q, blue);
        if(i>0) {
            M = midpoint(T,Q);
            circ = hyperbolic_circle(M, Q);
            //W = hyperbolic_regular_ngon(M, Q, s);
            //fill(W, blue+opacity(0.2));
            draw(circ);
            dot(circ, orange);
        }
        T = Q;
    }
    radius += 0.5;
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
