import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// The rotation of hyperbolic circles around points

hyperbolic_point O = hyperbolic_point(0,0);
dot(O, black);
hyperbolic_point P = hyperbolic_point(2.0, 285);
dot(P, blue);

hyperbolic_point A = hyperbolic_point(1.8,20);
hyperbolic_point B = hyperbolic_point(1.5,340);
dot(A, blue);
dot(B, blue);

hyperbolic_circle T = hyperbolic_circle(A,B);
fill(T, blue+opacity(0.4));
draw(T);
dot(T);

hyperbolic_ray L = hyperbolic_ray(P,A);
draw(L, gray);

hyperbolic_point[] I = intersection(L, T);
dot(I, black);

hyperbolic_circle C1 = hyperbolic_circle(P,I[0]);
hyperbolic_circle C2 = hyperbolic_circle(P,I[1]);
draw(C1, gray);
draw(C2, gray);

hyperbolic_circle C3 = hyperbolic_circle(P,A);
draw(C3, gray);

hyperbolic_circle K;
int maxi = 72;
for(int i = 1; i < maxi; ++i) {
    K = rotate(P, T, 360/maxi*i);
    draw(K, blue+opacity(0.5));
    dot(K, blue);
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
