import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// The rotation of points around the origin.

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

hyperbolic_point P;
hyperbolic_point Q;
hyperbolic_circle C;

int maxsteps = 25;
real radius = 0.1;

for(int s = 2; s <= maxsteps; ++s) {
    P = hyperbolic_point(radius, 20);
    dot(P, black);
    C = hyperbolic_circle(O, P);
    draw(C, gray+opacity(0.3));
    for(int i = 0; i <= s; ++i) {
        Q = rotate_around_origin(P, i*360/s);
        dot(Q, blue);
    }
    radius += 0.2;
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
