import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Some triangles in the hyperbolic plane.

hyperbolic_point P1 = hyperbolic_point((0.9,0.2));
hyperbolic_point P2 = hyperbolic_point((-0.2,0.9));
hyperbolic_point P3 = hyperbolic_point((0.2,-0.9));

hyperbolic_triangle r = hyperbolic_triangle(P1,P2,P3);
hyperbolic_circle C = circumcircle(r);
draw(C, gray);
hyperbolic_circle C = incircle(r);
draw(C, orange);
fill(r, blue+opacity(0.5));
draw(r);
dot(r);


hyperbolic_point Q1 = hyperbolic_point((0.5,0.4));
hyperbolic_point Q2 = hyperbolic_point(-(0.8,0.3));
hyperbolic_point Q3 = hyperbolic_point((0,-0.9));

hyperbolic_triangle s = hyperbolic_triangle(Q2, Q1, Q3);
hyperbolic_circle C = circumcircle(s);
draw(C, gray);
hyperbolic_circle C = incircle(s);
draw(C, orange);
fill(s, green+opacity(0.5));
draw(s);
dot(s);


hyperbolic_point R1 = hyperbolic_point((0,0.5));
hyperbolic_point R2 = hyperbolic_point(-(0.5*sin(120), 0.5*cos(120)));
hyperbolic_point R3 = hyperbolic_point((0.5*sin(240), 0.5*cos(240)));

hyperbolic_triangle t = hyperbolic_triangle(R3,R1,R2);
hyperbolic_circle C = circumcircle(t);
draw(C, gray);
hyperbolic_circle C = incircle(t);
draw(C, orange);
fill(t, red+opacity(0.5));
draw(t);
dot(t);


hyperbolic_point R1 = hyperbolic_point((0.3,0.9));
hyperbolic_point R2 = hyperbolic_point((-0.4,0.7));
hyperbolic_point R3 = hyperbolic_point((-0.36,-0.1));

hyperbolic_triangle t = hyperbolic_triangle(R3,R1,R2);
hyperbolic_circle C = circumcircle(t);
draw(C, gray);
hyperbolic_circle C = incircle(t);
draw(C, orange);
fill(t, red+opacity(0.5));
draw(t);
dot(t);


hyperbolic_point R1 = hyperbolic_point((0.9,0));
hyperbolic_point R2 = hyperbolic_point((0.9*cos(120),0.9*sin(120)));
hyperbolic_point R3 = hyperbolic_point((-0.9*cos(240),-0.9*sin(240)));

hyperbolic_triangle t = hyperbolic_triangle(R3,R1,R2);
hyperbolic_circle C = circumcircle(t);
draw(C, gray);
hyperbolic_circle C = incircle(t);
draw(C, orange);
fill(t, yellow+opacity(0.5));
draw(t);
dot(t);


hyperbolic_point R1 = hyperbolic_point((0.9,0));
hyperbolic_point R2 = hyperbolic_point((0.9*cos(120),0.9*sin(120)));
hyperbolic_point R3 = hyperbolic_point((0.9*cos(240),0.9*sin(240)));

hyperbolic_triangle t = hyperbolic_triangle(R3,R1,R2);
hyperbolic_circle C = circumcircle(t);
draw(C, gray);
hyperbolic_circle C = incircle(t);
draw(C, orange);
fill(t, orange+opacity(0.5));
draw(t);
dot(t);


hyperbolic_point R1 = hyperbolic_point(2,90);
hyperbolic_point R2 = hyperbolic_point(0,0);
hyperbolic_point R3 = hyperbolic_point(2,180);

hyperbolic_triangle t = hyperbolic_triangle(R3,R1,R2);
hyperbolic_circle C = circumcircle(t);
draw(C, gray);
hyperbolic_circle C = incircle(t);
draw(C, orange);
fill(t, blue+opacity(0.3));
draw(t);
dot(t);


hyperbolic_point R1 = hyperbolic_point(1,0);
hyperbolic_point R2 = hyperbolic_point(1,120);
hyperbolic_point R3 = hyperbolic_point(1,240);

hyperbolic_triangle t = hyperbolic_triangle(R3,R1,R2);
hyperbolic_circle C = circumcircle(t);
draw(C, gray);
hyperbolic_circle C = incircle(t);
draw(C, orange);
fill(t, green+opacity(0.3));
draw(t);
dot(t);


hyperbolic_point R1 = hyperbolic_point(3,210);
hyperbolic_point R2 = hyperbolic_point(5,230);
hyperbolic_point R3 = hyperbolic_point(3,260);

hyperbolic_triangle t = hyperbolic_triangle(R3,R1,R2);
hyperbolic_circle C = circumcircle(t);
draw(C, gray);
hyperbolic_circle C = incircle(t);
draw(C, orange);
fill(t, yellow+opacity(0.3));
draw(t);
dot(t);

// And finally an invalid one to test the invalidity framework
hyperbolic_point R1 = hyperbolic_point(3,210);
hyperbolic_point R2 = hyperbolic_point(3,210);
hyperbolic_point R3 = hyperbolic_point(3,260);

hyperbolic_triangle t = hyperbolic_triangle(R3,R1,R2);
hyperbolic_circle C = circumcircle(t);
draw(C, gray);
hyperbolic_circle C = incircle(t);
draw(C, orange);
fill(t, black+opacity(0.3));
draw(t);
dot(t);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1));
draw(unitcircle);
