import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Measuring the length, angles and area of a triangle.

hyperbolic_point Q1 = hyperbolic_point((0.5,0.4));
hyperbolic_point Q2 = hyperbolic_point(-(0.8,0.3));
hyperbolic_point Q3 = hyperbolic_point((0,-0.9));

// hyperbolic_point Q1 = hyperbolic_point(1.2,0);
// hyperbolic_point Q2 = hyperbolic_point(0.8,90);
// hyperbolic_point Q3 = hyperbolic_point(0,0);

// hyperbolic_point Q1 = hyperbolic_point(1.2,0);
// hyperbolic_point Q2 = hyperbolic_point(1.2,120);
// hyperbolic_point Q3 = hyperbolic_point(1.2,240);

// hyperbolic_point Q1 = hyperbolic_point(5.0,0);
// hyperbolic_point Q2 = hyperbolic_point(5.0,90);
// hyperbolic_point Q3 = hyperbolic_point(0.0,0);

hyperbolic_triangle T = hyperbolic_triangle(Q2, Q1, Q3);
fill(T, blue+opacity(0.5));
draw(T);
dot(T);

// The sidelength
real l = T.c();
string s = string(l, 2);
label(s,(T.AB().get_first_point().get_euclidean()+T.AB().get_second_point().get_euclidean())/2.0);

real l = T.a();
string s = string(l, 2);
label(s,(T.BC().get_first_point().get_euclidean()+T.BC().get_second_point().get_euclidean())/2.0);

real l = T.b();
string s = string(l, 2);
label(s,(T.CA().get_first_point().get_euclidean()+T.CA().get_second_point().get_euclidean())/2.0);

// The angles (in radians!)
real l = T.alpha();
string s = string(l, 2);
label(s,T.A().get_euclidean());

real l = T.beta();
string s = string(l, 2);
label(s,T.B().get_euclidean());

real l = T.gamma();
string s = string(l, 2);
label(s,T.C().get_euclidean());

// The area
real l = T.area();
string s = string(l, 4);
label(s,(T.A().get_euclidean()+T.B().get_euclidean()+T.C().get_euclidean())/3);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1));
draw(unitcircle);
